#include <windows.h>
#include <stdio.h>
#include <string.h>

long int leadinend=-1;
long int leadoutstart=-1;
int long SectorCounter;
//bool IsSilent =true; 

UCHAR ISRCBuffer[12];
UCHAR TempISRC[12];

UCHAR GetISRCBuffer(byte IND)
{
    return ISRCBuffer[IND];
} 

long int GetLeadInEnd()
{
    return leadinend;
};

long int GetLeadOutStart()
{
    return leadoutstart;
};

void DetectSilence(byte SectorToAnalyse,UCHAR *DataBuf)
{
    const int MaxVolume=2352*2;
    
    short int ThisSample;
    short int idx;
    int Volume=0;
    for (idx=0;(idx<2352)&&(Volume<MaxVolume);idx+=2)
    
    {
        ThisSample=(DataBuf[idx+1+(SectorToAnalyse*2448)]<<8) | 
                            (DataBuf[idx+(SectorToAnalyse*2448)]);
        if (ThisSample<0)
            ThisSample=-ThisSample;
        Volume+=ThisSample;
    };   
    
    
    if (!(Volume<MaxVolume))
    {
      leadoutstart=SectorCounter;
      if (leadinend==(-1))
      {
            leadinend=SectorCounter; 
      };
    };
    //IsSilent=(Volume<MaxVolume);
    SectorCounter++;
};

void ExtractQDataToISRCBuffer(byte SectorToDecode,UCHAR *DataBuf)
{   
    UCHAR QData=0;
    UCHAR CharNum=0;
    for(int i=2352;(i<2448);i++)
    {
        QData=QData<<1;
        if (DataBuf[i+(SectorToDecode*2448)]&&0x40==0x40)
            {QData=QData+1;};
        
        if((i+1)%8==0)
        { 
            ISRCBuffer[CharNum]=QData;
            CharNum++;
            if (CharNum==12)
            {
                CharNum=0;
            };
            
        };
    };
}

bool FindUPCorISRC(byte SectorsToDecode, byte SearchFor,UCHAR *DataBuf)
{   
    bool FoundItem=false;
    for(int i=0;(i<(SectorsToDecode))&&!(FoundItem);i++)
    {
        ExtractQDataToISRCBuffer(i,DataBuf);
        if (ISRCBuffer[0]==SearchFor) 
        {
            //Its A UPC Code Check Its Consistent With the last ONE
            bool success=true;
            for(char ind=1;(ind<9)&&(success);ind++)
            {
                success=(TempISRC[ind]==ISRCBuffer[ind]);
            };

            if (success && (TempISRC[1]!=0))
            {       
                //IT Is Return Valid
                FoundItem=true;        
            }
            else
            {
                //we havent Found It Move it to the Temp Buffer and con
                
                for(char ind=1;(ind<9);ind++)
                {
                    TempISRC[ind]=ISRCBuffer[ind];
                };            
            };
         };
    };
    return FoundItem;
};

void OutputRawQData()
{
            printf("%02X",ISRCBuffer[0]);
            printf("%02X",ISRCBuffer[1]);
            printf("%02X",ISRCBuffer[2]);
            printf("%02X",ISRCBuffer[3]);
            printf("%02X",ISRCBuffer[4]);
            printf("%02X",ISRCBuffer[5]);
            printf("%02X",ISRCBuffer[6]);
            printf("%02X",ISRCBuffer[7]);
            printf("%02X",ISRCBuffer[8]);
            printf("%02X",ISRCBuffer[9]);
            printf("%02X",ISRCBuffer[10]);
            printf("%02X",ISRCBuffer[11]);
}


unsigned char DecodeAscPlus0(unsigned char WorkChar)
{
    
    return ('0'+WorkChar);

};

void OutputAscPlus0(unsigned char WorkChar)
{
    printf("%c",DecodeAscPlus0(WorkChar));

};


unsigned char *DecodeUPC()
{
    unsigned char *UPCCode;
    UPCCode=new unsigned char[14];      
    memset(UPCCode,0,14);
    for(byte i=0;i<13;i++)
    {
        if (i%2==0)
        {
            UPCCode[i]=DecodeAscPlus0( ISRCBuffer[1+(i/2)] >> 4);
        }
        else
        {
            UPCCode[i]=DecodeAscPlus0(ISRCBuffer[1+(i/2)] & 0x0f);
        }
    };
    return UPCCode;
};

 
unsigned char *DecodeISRCCode()
{
    //char OutCar;
    unsigned char    WorkChar;
    unsigned char *ISRCCode;
    ISRCCode=new unsigned char[13];   
    
    memset(ISRCCode,0,13);

    WorkChar= ISRCBuffer[1]>>2; 
    ISRCCode[0]=DecodeAscPlus0(WorkChar);
      
    WorkChar= (((ISRCBuffer[1]<<6) & 0xff) >>2) | (ISRCBuffer[2]>>4); 
    ISRCCode[1]=DecodeAscPlus0(WorkChar);
    
    WorkChar= (((ISRCBuffer[2]<<4) & 255)>>2) | (ISRCBuffer[3]>>6); 
    ISRCCode[2]=DecodeAscPlus0(WorkChar);

    WorkChar= (((ISRCBuffer[3]<<2) & 255)>>2); 
    ISRCCode[3]=DecodeAscPlus0(WorkChar);

    WorkChar= (ISRCBuffer[4]>>2); 
    ISRCCode[4]=DecodeAscPlus0(WorkChar);
    
    ISRCCode[5]=DecodeAscPlus0(ISRCBuffer[5] >> 4);
    ISRCCode[6]=DecodeAscPlus0(ISRCBuffer[5] & 0x0f);

    ISRCCode[7]=DecodeAscPlus0(ISRCBuffer[6] >> 4);
    ISRCCode[8]=DecodeAscPlus0(ISRCBuffer[6] & 0x0f);

    ISRCCode[9]=DecodeAscPlus0(ISRCBuffer[7] >> 4);
    ISRCCode[10]=DecodeAscPlus0(ISRCBuffer[7] & 0x0f);

    ISRCCode[11]=DecodeAscPlus0(ISRCBuffer[8] >> 4);
    
    return ISRCCode;
};





